%def_disable java
%def_disable php
%def_enable qyoto
%def_disable soprano
%def_disable ruby

#define __kde4_alternate_placement 1

%define rname kdebindings
Name: kde4bindings
%define major 4
%define minor 2
%define bugfix 4
Version: %major.%minor.%bugfix
Release: alt0.M50.1

Group: Graphical desktop/KDE
Summary: KDE bindings to non-C++ languages
License: GPL
Url: http://www.kde.org

Requires: python-module-kde4 = %version-%release
%if_enabled qyoto
Requires: qyoto = %version-%release
Requires: kimono = %version-%release
%endif
%if_enabled ruby
Requires: ruby-qt4 = %version-%release
Requires: ruby-kde4 = %version-%release
%endif

Source: ftp://ftp.kde.org/pub/kde/stable/%version/src/%rname-%version.tar
Source10: qt-dotnet.dll.config
Source11: kde-dotnet.dll.config
Patch1: kdebindings-4.1.3-trunk-python-sip.patch
Patch2: kdebindings-4.1.3-trunk-fix-build-qyoto.patch
#
Patch101: kdebindings-4.1.0-alt-fix-test-qt.patch
Patch102: kdebindings-4.1.0-alt-gac-assemply-dir.patch
Patch103: kdebindings-4.2.3-alt-gcc44.patch
# MDK
Patch202: kdebindings-4.1.81-smoke-phonon.patch

# buildreq -bi 2008.10.17
#akonadi-devel gcc-c++ kde4base-devel kde4base-runtime kde4base-workspace-devel kde4network-devel libXScrnSaver-devel libXcomposite-devel libXft-devel libXpm-devel libXt-devel libXtst-devel libXv-devel libXxf86misc-devel libjpeg-devel libpth-devel libqscintilla2-qt4-devel libruby-devel libxkbfile-devel python-module-PyQt4-devel python-module-sip-devel ruby-module-etc xorg-xf86vidmodeproto-devel
BuildRequires(pre): kde4libs-devel python-module-PyQt4-devel python-module-sip rpm-build-mono rpm-build-python rpm-build-ruby
BuildRequires: kde4libs-devel >= %version
BuildRequires: kde4pimlibs-devel >= %version
BuildRequires: kde4base-workspace-devel >= %version
BuildRequires: kde4base-devel >= %version
BuildRequires: kde4base-runtime >= %version
BuildRequires: kde4network-devel >= %version
BuildRequires: kde4graphics-devel >= %version
BuildRequires: gcc-c++ akonadi-devel libsoprano-devel
BuildRequires: xorg-devel libjpeg-devel libpth-devel
%if_enabled java
BuildRequires: java-devel
%endif
BuildRequires: libruby-devel ruby-module-etc
BuildRequires: libmono-devel mono-devel mono-mcs /proc
BuildRequires: python-devel
BuildRequires: phonon-devel
BuildRequires: python-module-sip-devel >= 4.7.6
BuildRequires: python-module-PyQt4-devel >= 4.4.2
BuildRequires: libqscintilla2-qt4-devel
%if_enabled php
BuildRequires: php-devel
BuildRequires: php-cli
%endif


%description
KDE4 bindings to non-C++ languages

%package common
Summary: Common package for %name
Group: System/Configuration/Other
Requires: kde-common >= %major.%minor
%description common
Common package for %name

%package -n python-module-kde4
Summary: PyKDE4
Group: Development/KDE and QT
Requires: %name-common = %version-%release
Requires: libsoprano >= %{get_version libsoprano}
Requires: python-module-PyQt4 >= %{get_version python-module-PyQt4}
Requires: python-module-sip >= %{get_version python-module-sip}
Provides: PyKDE4 = %version-%release
%description -n python-module-kde4
Python KDE 4

%package -n python-module-kde4-doc
Summary: PyKDE4 documentation
Group: Development/KDE and QT
Requires: %name-common = %version-%release
%description -n python-module-kde4-doc
Python KDE 4 documentation

%package -n   libsmokekde4
Summary: KDE generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: %{get_dep kde4libs}
%description -n libsmokekde4
KDE generic bindings library.

%package -n   libsmokephonon4
Summary: KDE generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
%description -n libsmokephonon4
KDE generic bindings library.

%package -n   libsmokekhtml4
Summary: KDE generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: %{get_dep kde4libs}
%description -n libsmokekhtml4
KDE generic bindings library.

%package -n   libsmokektexteditor4
Summary: KDE generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: %{get_dep kde4libs}
%description -n libsmokektexteditor4
KDE generic bindings library.

%package -n   libsmokeqtuitools4
Summary: KDE generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
%description -n libsmokeqtuitools4
KDE generic bindings library.

%package -n   libsmokeqtwebkit4
Summary: KDE generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
%description -n libsmokeqtwebkit4
KDE generic bindings library.

%package -n   libsmokesolid4
Summary: KDE generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
#Requires: %{get_dep kde4libs}
%description -n libsmokesolid4
KDE generic bindings library.

%package -n libsmokeokular4
Summary: KDE generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: %{get_dep kde4libs}
%description -n libsmokeokular4
KDE generic bindings library.

%package -n   libsmokeqsci4
Summary: KDE generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
%description -n libsmokeqsci4
KDE generic bindings library.

%package -n libsmokesoprano4
Summary: Qt generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
Requires: libsoprano >= %{get_version libsoprano}
%description -n libsmokesoprano4
Qt generic bindings library.

%package -n libsmokeqtscript4
Summary: Qt generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
%description -n libsmokeqtscript4
Qt generic bindings library.

%package -n libsmokenepomuk4
Summary: Qt generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
%description -n libsmokenepomuk4
Qt generic bindings library.

%package -n libsmokeqt4
Summary: Qt generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
%description -n libsmokeqt4
Qt generic bindings library.

%package -n libsmokeqttest4
Summary: Qt generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
%description -n libsmokeqttest4
Qt generic bindings library.

%package -n libqtruby4shared
Summary: Qt generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
%description -n libqtruby4shared
Qt generic bindings library.

%package -n libsmokeakonadi4
Summary: Qt generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: %{get_dep kde4libs}
%description -n libsmokeakonadi4
Qt generic bindings library.

%package -n libsmokeplasma4
Summary: Qt generic bindings library
Group: System/Libraries
Requires: %name-common = %version-%release
Requires: %{get_dep kde4libs}
%description -n libsmokeplasma4
Qt generic bindings library.

%package -n smoke4-devel
Summary: Header files for libsmoke
Group: Development/KDE and QT
Requires: %name-common = %version-%release
%description -n smoke4-devel
Smoke devel files.

%package -n qyoto
Summary: C# Mono Qt 4 bindings
Group: Development/KDE and QT
Requires: %name-common = %version-%release
Requires: mono
Provides: mono-qt4 = %version-%release
%description -n qyoto
C# Mono Qt 4 bindings

%package -n kimono
Summary: C# Mono KDE 4 bindings
Group: Development/KDE and QT
Requires: %name-common = %version-%release
Requires: mono
Requires: qyoto
Provides: mono-kde4 = %version-%release
%description -n kimono
C# Mono KDE 4 bindings

%package -n qyoto-devel
Summary: Header files for qyoto
Group: Development/KDE and QT
Requires: %name-common = %version-%release
Requires: qyoto
%description -n qyoto-devel
qyoto devel files.

%package -n kimono-devel
Summary: Devel files for kimono
Group: Development/KDE and QT
Requires: %name-common = %version-%release
Requires: qyoto-devel
Requires: kimono
%description -n kimono-devel
kimono devel files.

%package -n ruby-qt4
Summary: Qt bindings for Ruby
Group: Development/KDE and QT
Requires: %name-common = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
Provides: ruby-qt = %version-%release
Obsoletes: ruby-qt < %version-%release
Provides: ruby-module-qt = %version-%release
Obsoletes: ruby-module-qt < %version-%release
%description -n ruby-qt4
A qt4 bindings for Ruby language.

%package -n ruby-kde4
Summary: KDE bindings for Ruby
Group: Development/KDE and QT
Requires: %name-common = %version-%release
Requires: %{get_dep kde4libs}
%description -n ruby-kde4
A kde4 bindings for Ruby language.

%package -n ruby-qt4-devel
Summary: Header files for ruby-qt4
Group: Development/KDE and QT
Requires: ruby-qt4
Requires: %name-common = %version-%release
%description -n ruby-qt4-devel
ruby-qt4 devel files.

%package -n ruby-kde4-devel
Summary: Header files for ruby-kde4
Group: Development/KDE and QT
Requires: %name-common = %version-%release
Requires: ruby-qt4-devel
Requires: ruby-kde4
%description -n ruby-kde4-devel
ruby-kde4 devel files.


%prep
%setup -q -n %rname-%version
#%patch1 -p3
#%patch2 -p3
%patch101 -p1
%patch102 -p1
%patch103 -p1
#%patch202 -p0
rm -rf xparts %{!?_enable_java:java} %{!?_enable_php:php} %{!?_enable_qyoto:csharp} %{!?_enable_ruby:ruby}

%build
export QTDIR=%_qt4dir
%K4cmake \
	-DWITH_Soprano:BOOL=%{?_enable_soprano:ON}%{!?_enable_soprano:OFF} \
	-DGAC_ASSEMBLY_DIR:STRING=%_monodir \
	-DCUSTOM_RUBY_SITE_ARCH_DIR:STRING=%ruby_sitearchdir \
	-DCUSTOM_RUBY_SITE_LIB_DIR:STRING=%ruby_sitelibdir \
	-DBUILD_ruby:BOOL=%{?_enable_ruby:ON}%{!?_enable_ruby:OFF} \
	-DENABLE_KROSSJAVA:BOOL=%{?_enable_java:ON}%{!?_enable_java:OFF} \
	-DENABLE_PHP-QT:BOOL=%{?_enable_php:ON}%{!?_enable_php:OFF} \
	-DENABLE_QYOTO:BOOL=%{?_enable_qyoto:ON}%{!?_enable_qyoto:OFF} \
	-DENABLE_QSCINTILLA_SHARP:BOOL=ON \
	-DENABLE_QSCINTILLA_RUBY:BOOL=ON \
	-DENABLE_SMOKEKDEVPLATFORM:BOOL=OFF

%K4make -j1


%install
%K4install
install -m 0644 %SOURCE10 %buildroot%_monogacdir/qt-dotnet/*/
install -m 0644 %SOURCE11 %buildroot%_monogacdir/kde-dotnet/*/


%files
%files common


%files -n libsmokeakonadi4
%_K4libdir/libsmokeakonadi.so.*

%files -n libsmokeplasma4
%_K4libdir/libsmokeplasma.so.*

%files -n libsmokekde4
%_K4libdir/libsmokekde.so.*

#%files -n libsmokephonon4
#%_K4libdir/libsmokephonon.so.*

%files -n libsmokekhtml4
%_K4libdir/libsmokekhtml.so.*

%files -n libsmokektexteditor4
%_K4libdir/libsmokektexteditor.so.*

%files -n libsmokeqtuitools4
%_K4libdir/libsmokeqtuitools.so.*

%files -n libsmokeqtwebkit4
%_K4libdir/libsmokeqtwebkit.so.*

%files -n libsmokesolid4
%_K4libdir/libsmokesolid.so.*

%files -n libsmokeokular4
%_K4libdir/libsmokeokular.so.*

%files -n libsmokeqsci4
%_K4libdir/libsmokeqsci.so.*

%if_enabled soprano
%files -n libsmokesoprano4
%_K4libdir/libsmokesoprano.so.*

%files -n libsmokenepomuk4
%_K4libdir/libsmokenepomuk.so.*
%endif

%files -n libsmokeqtscript4
%_K4libdir/libsmokeqtscript.so.*

%files -n libsmokeqt4
%_K4libdir/libsmokeqt.so.*

%files -n libsmokeqttest4
%_K4libdir/libsmokeqttest.so.*

%files -n smoke4-devel
%_includedir/smoke.h
%_includedir/smoke
%_K4libdir/libsmoke*.so

%if_enabled qyoto
%files -n qyoto
%_monodir/2.0/qt-dotnet.dll
%_monodir/2.0/qscintilla.dll
%_monodir/2.0/qtscript.dll
%_monodir/2.0/qtuitools.dll
%_monodir/2.0/qtwebkit.dll
%_monodir/2.0/qttest.dll
%_monogacdir/qt-dotnet
%_monogacdir/qscintilla
%_monogacdir/qtscript
%_monogacdir/qtwebkit
%_monogacdir/qtuitools
%_monogacdir/qttest
%_K4libdir/libqyoto.so
%_K4libdir/libqyotoshared.so.*
%_K4libdir/libqttest-sharp.so
%_K4libdir/libqscintilla-sharp.so
%_K4libdir/libqtscript-sharp.so
%_K4libdir/libqtuitools-sharp.so
%_K4libdir/libqtwebkit-sharp.so
%endif

%if_enabled qyoto
%files -n qyoto-devel
%_K4bindir/csrcc
%_K4bindir/uics
# %_K4includedir/qyoto
%_includedir/qyoto
%_K4libdir/libqyotoshared.so
%endif

%if_enabled qyoto
%files -n kimono
%_monodir/2.0/kde-dotnet.dll
%_monodir/2.0/khtml-dll.dll
%_monodir/2.0/akonadi.dll
%_monodir/2.0/ktexteditor-dotnet.dll
%_monodir/2.0/plasma-dll.dll
%_monogacdir/akonadi
%_monogacdir/ktexteditor-dotnet
%_monogacdir/plasma-dll
%_monogacdir/kde-dotnet
%_monogacdir/khtml-dll
%_K4lib/kimonopluginfactory.so
%_K4libdir/libkhtml-sharp.so
%_K4libdir/libkimono.so
%_K4libdir/libakonadi-sharp.so
%_K4libdir/libktexteditor-sharp.so
%_K4libdir/libplasma-sharp.so
%_K4apps/plasma_scriptengine_kimono/PlasmaScriptengineKimono.dll
%_K4srv/plasma-scriptengine-kimono-applet.desktop
%_K4srv/plasma-scriptengine-kimono-dataengine.desktop
%if_enabled soprano
%_monogacdir/soprano
%_monogacdir/nepomuk
%_monodir/2.0/soprano.dll
%_monodir/2.0/nepomuk.dll
%_K4libdir/libnepomuk-sharp.so
%_K4libdir/libsoprano-sharp.so
%endif
%endif

%if_enabled qyoto
%files -n kimono-devel
%endif

%if_enabled ruby
%files -n libqtruby4shared
%_K4libdir/libqtruby4shared.so.*
%endif

%if_enabled ruby
%files -n ruby-qt4
%_bindir/rbqtapi
%_libdir/libqtruby4shared.so
%_K4xdg_apps/dbpedia_references.desktop
%_K4apps/dbpedia_references
%ruby_sitearchdir/qscintilla.so
%ruby_sitearchdir/qtruby4.so
%ruby_sitearchdir/qtuitools.so
%ruby_sitearchdir/qtwebkit.so
%ruby_sitearchdir/qtscript.so
%ruby_sitelibdir/Qt.rb
%ruby_sitelibdir/Qt3.rb
%ruby_sitelibdir/Qt4.rb
%ruby_sitelibdir/Qt
%ruby_sitelibdir/qscintilla
%ruby_sitelibdir/qtuitools
%ruby_sitelibdir/qtwebkit
%ruby_sitelibdir/qtscript
%endif

%if_enabled ruby
%files -n ruby-qt4-devel
%_bindir/rbrcc
%_bindir/rbuic4
%_bindir/rbkconfig_compiler4
%_includedir/qtruby
%endif

%if_enabled ruby
%files -n ruby-kde4
%_bindir/krubyapplication
%_K4lib/krossruby.so
%_K4lib/krubypluginfactory.so
%ruby_sitearchdir/khtml.so
%ruby_sitearchdir/korundum4.so
%ruby_sitearchdir/ktexteditor.so
%ruby_sitearchdir/solid.so
%ruby_sitelibdir/KDE
%ruby_sitelibdir/khtml
%ruby_sitelibdir/ktexteditor
%ruby_sitelibdir/solid
#
%ruby_sitearchdir/akonadi.so
%ruby_sitearchdir/plasma_applet.so
#%_K4apps/plasma_ruby_web_applet/
%_K4apps/plasma_scriptengine_ruby/
#%_K4srv/plasma-ruby-applet-web.desktop
%_K4srv/plasma-scriptengine-ruby-applet.desktop
%_K4srv/plasma-scriptengine-ruby-dataengine.desktop
%_K4srv/plasma-scriptengine-ruby-package.desktop
%ruby_sitelibdir/akonadi/
%if_enabled soprano
%ruby_sitearchdir/phonon.so
%ruby_sitearchdir/soprano.so
%ruby_sitearchdir/nepomuk.so
%ruby_sitelibdir/phonon
%ruby_sitelibdir/soprano
%ruby_sitelibdir/nepomuk
%endif
%endif

%if_enabled ruby
%files -n ruby-kde4-devel
# requires ruby-qt4-devel
%endif

%files -n python-module-kde4
%dir %python_sitelibdir/PyKDE4
%python_sitelibdir/PyKDE4/*
%_datadir/sip/PyKDE4/*
%_K4apps/pykde4
%_K4lib/krosspython.so
%_K4lib/kpythonpluginfactory.so

%files -n python-module-kde4-doc
#%_K4doc/*/pykde4

%changelog
* Mon Jun 22 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt0.M50.1
- built for M50

* Mon Jun 08 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt1
- new version

* Tue May 05 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.3-alt1
- new version

* Fri Apr 03 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.2-alt1
- new version

* Mon Mar 16 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.1-alt0.M50.1
- built for M50

* Wed Mar 04 2009 Sergey V Turchin <zerg at altlinux dot org> 4.2.1-alt1
- new version

* Wed Jan 28 2009 Sergey V Turchin <zerg at altlinux dot org> 4.2.0-alt1
- new version

* Tue Jan 20 2009 Sergey V Turchin <zerg at altlinux dot org> 4.1.96-alt1
- new version

* Mon Jan 12 2009 Sergey V Turchin <zerg at altlinux dot org> 4.1.3-alt4
- fix to build mono bondings; thanks shaba@alt

* Mon Dec 01 2008 Sergey V Turchin <zerg at altlinux dot org> 4.1.3-alt3
- add fix from trunk to build with new python-sip

* Mon Nov 24 2008 Sergey V Turchin <zerg at altlinux dot org> 4.1.3-alt2
- don't build ruby module

* Fri Nov 07 2008 Sergey V Turchin <zerg at altlinux dot org> 4.1.3-alt1
- new version

* Fri Oct 24 2008 Sergey V Turchin <zerg at altlinux dot org> 4.1.2-alt3
- fix requires

* Wed Oct 22 2008 Sergey V Turchin <zerg at altlinux dot org> 4.1.2-alt2
- fix typo in package name

* Wed Oct 08 2008 Sergey V Turchin <zerg at altlinux dot org> 4.1.2-alt1
- new version

* Fri Aug 22 2008 Sergey V Turchin <zerg at altlinux dot org> 4.1.0-alt0.1
- initial specfile

